// Code generated by Community Administration CLI. DO NOT EDIT.

package model

import (
	"reflect"

	"github.com/invopop/jsonschema"
	"github.com/stoewer/go-strcase"
)

type TypeMemberEvent string

const (
	PERSON_APPROVED                           TypeMemberEvent = "PERSON_APPROVED"
	CREATE_PAYMENT_REQUEST                    TypeMemberEvent = "CREATE_PAYMENT_REQUEST"
	APPLICATION_FORM_SENT                     TypeMemberEvent = "APPLICATION_FORM_SENT"
	PAYMENT_COMPLETED                         TypeMemberEvent = "PAYMENT_COMPLETED"
	SUBSCRIPTION_FORM_RECEIVED                TypeMemberEvent = "SUBSCRIPTION_FORM_RECEIVED"
	SUBSCRIPTION_PAYED                        TypeMemberEvent = "SUBSCRIPTION_PAYED"
	MEMBER_INFO_COMPLETED                     TypeMemberEvent = "MEMBER_INFO_COMPLETED"
	PAYMENT_CONFIRMATION_LETTER_CREATED       TypeMemberEvent = "PAYMENT_CONFIRMATION_LETTER_CREATED"
	PAYMENT_CONFIRMATION_SENT                 TypeMemberEvent = "PAYMENT_CONFIRMATION_SENT"
	WELCOME_LETTER_SENT                       TypeMemberEvent = "WELCOME_LETTER_SENT"
	MEMBERSHIP_ID_ASSIGNED                    TypeMemberEvent = "MEMBERSHIP_ID_ASSIGNED"
	MEMBER_INFO_CHANGED                       TypeMemberEvent = "MEMBER_INFO_CHANGED"
	SUBSCRIPTION_RENEWAL_SENT                 TypeMemberEvent = "SUBSCRIPTION_RENEWAL_SENT"
	MEMBERSHIP_CANCELLATION_RECEIVED          TypeMemberEvent = "MEMBERSHIP_CANCELLATION_RECEIVED"
	MEMBERSHIP_CANCELLATION_CONFIRMATION_SENT TypeMemberEvent = "MEMBERSHIP_CANCELLATION_CONFIRMATION_SENT"
	MEMBERSHIP_CANCELLED                      TypeMemberEvent = "MEMBERSHIP_CANCELLED"
)

type MemberEventType struct {
	Type TypeMemberEvent `json:"type" jsonschema:"enum=PERSON_APPROVED,enum=CREATE_PAYMENT_REQUEST,enum=APPLICATION_FORM_SENT,enum=PAYMENT_COMPLETED,enum=SUBSCRIPTION_FORM_RECEIVED,enum=SUBSCRIPTION_PAYED,enum=MEMBER_INFO_COMPLETED,enum=PAYMENT_CONFIRMATION_LETTER_CREATED,enum=PAYMENT_CONFIRMATION_SENT,enum=WELCOME_LETTER_SENT,enum=MEMBERSHIP_ID_ASSIGNED,enum=MEMBER_INFO_CHANGED,enum=SUBSCRIPTION_RENEWAL_SENT,enum=MEMBERSHIP_CANCELLATION_RECEIVED,enum=MEMBERSHIP_CANCELLATION_CONFIRMATION_SENT,enum=MEMBERSHIP_CANCELLED"`
}

func (e PersonApproved) isMemberEvent() {}

func (e PersonApproved) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e CreatePaymentRequest) isMemberEvent() {}

func (e CreatePaymentRequest) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e ApplicationFormSent) isMemberEvent() {}

func (e ApplicationFormSent) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e PaymentCompleted) isMemberEvent() {}

func (e PaymentCompleted) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e SubscriptionFormReceived) isMemberEvent() {}

func (e SubscriptionFormReceived) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e SubscriptionPayed) isMemberEvent() {}

func (e SubscriptionPayed) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MemberInfoCompleted) isMemberEvent() {}

func (e MemberInfoCompleted) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e PaymentConfirmationLetterCreated) isMemberEvent() {}

func (e PaymentConfirmationLetterCreated) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e PaymentConfirmationSent) isMemberEvent() {}

func (e PaymentConfirmationSent) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e WelcomeLetterSent) isMemberEvent() {}

func (e WelcomeLetterSent) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MembershipIdAssigned) isMemberEvent() {}

func (e MembershipIdAssigned) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MemberInfoChanged) isMemberEvent() {}

func (e MemberInfoChanged) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e SubscriptionRenewalSent) isMemberEvent() {}

func (e SubscriptionRenewalSent) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MembershipCancellationReceived) isMemberEvent() {}

func (e MembershipCancellationReceived) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MembershipCancellationConfirmationSent) isMemberEvent() {}

func (e MembershipCancellationConfirmationSent) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func (e MembershipCancelled) isMemberEvent() {}

func (e MembershipCancelled) GetBaseMemberEvent() BaseMemberEvent {
	return e.BaseMemberEvent
}

func GetReflectedMemberEventTypeStructSlice() (*[]*jsonschema.Schema, error) {
	reflector := new(jsonschema.Reflector)
	reflector.BaseSchemaID = "https://community-administration-cli.nl/schema"

	reflector.KeyNamer = strcase.LowerCamelCase

	if err := reflector.AddGoComments("gitlab.com/z.amir/community-administration-cli", "./"); err != nil {
		return nil, err
	}

	reflectedEvents := []*jsonschema.Schema{
		reflector.ReflectFromType(reflect.TypeOf(&PersonApproved{})),
		reflector.ReflectFromType(reflect.TypeOf(&CreatePaymentRequest{})),
		reflector.ReflectFromType(reflect.TypeOf(&ApplicationFormSent{})),
		reflector.ReflectFromType(reflect.TypeOf(&PaymentCompleted{})),
		reflector.ReflectFromType(reflect.TypeOf(&SubscriptionFormReceived{})),
		reflector.ReflectFromType(reflect.TypeOf(&SubscriptionPayed{})),
		reflector.ReflectFromType(reflect.TypeOf(&MemberInfoCompleted{})),
		reflector.ReflectFromType(reflect.TypeOf(&PaymentConfirmationLetterCreated{})),
		reflector.ReflectFromType(reflect.TypeOf(&PaymentConfirmationSent{})),
		reflector.ReflectFromType(reflect.TypeOf(&WelcomeLetterSent{})),
		reflector.ReflectFromType(reflect.TypeOf(&MembershipIdAssigned{})),
		reflector.ReflectFromType(reflect.TypeOf(&MemberInfoChanged{})),
		reflector.ReflectFromType(reflect.TypeOf(&SubscriptionRenewalSent{})),
		reflector.ReflectFromType(reflect.TypeOf(&MembershipCancellationReceived{})),
		reflector.ReflectFromType(reflect.TypeOf(&MembershipCancellationConfirmationSent{})),
		reflector.ReflectFromType(reflect.TypeOf(&MembershipCancelled{})),
	}

	return &reflectedEvents, nil
}
